global function AutoDoubleXpInit
global function SwitchDoubleXp
global function SetXpButtonText






void function AutoDoubleXpInit(){
    // WaitFrame()
    thread Monitor()
}

void function Monitor(){
    WaitFrame()
    SetScoreboardUpdateCallback(replaceScoreboard)
    while(true)
    {
        WaitFrame()
        if (AllowDoubleXp()) {
            UseDoubleXP()
        }
    }
}

void function SwitchDoubleXp() {
    bool value = GetConVarBool("autoxp_enable")
    SetConVarBool("autoxp_enable", !value)
    SetXpButtonText()
}

void function SetXpButtonText() {
    bool value = GetConVarBool("autoxp_enable")
    if (value) {
        RunUIScript("SetXpButton_Activate" )
    }
    else
    {
        RunUIScript("SetXpButton_Deactivate" )
    }
}

bool function AllowDoubleXp()
{
    if (!GetConVarBool("autoxp_enable")) {
        return false;
    }
	switch( GetGameState() )
	{
		case eGameState.WaitingForPlayers:
		case eGameState.PickLoadout:
		case eGameState.Prematch:
			return true;
			break

		default:
            return false;
			break
	}
    return false;
}

void function replaceScoreboard(entity e, var rui)
{
    if (!e.IsPlayer())
        return;

    entity player = GetLocalClientPlayer();

    // Patch
    if (player.GetPlayerNetInt("xpMultiplier") > 0 && e == player)
    {
        RuiSetImage( rui, "playerCard", GetItemDisplayData( "double_xp" ).image )
    }
}

